<?php
namespace App;

use DI\ContainerBuilder;
use Interop\Container\ContainerInterface;

class App extends \DI\Bridge\Slim\App {

    protected function configureContainer(ContainerBuilder $builder)
    {
        $definitions = [
            'settings.displayErrorDetails' => true,

            \Doctrine\DBAL\Connection::class => function () {
                
                if(!file_exists(__DIR__ . '/../environment/environment.json')) {
                    throw new \Exception("environment not found!");
                }

                $environmentFile = file_get_contents(__DIR__ . '/../environment/environment.json');
                $environment     = json_decode($environmentFile, true);

                $connection = null;

                if ($environment['driver'] == 'pdo_sqlite') {
                    $connection = \Doctrine\DBAL\DriverManager::getConnection(array(
                        'user'     => $environment['user'],
                        'password' => $environment['password'],
                        'path'     => $environment['path'],
                        'memory'   => $environment['memory'],
                        'driver'   => $environment['driver']
                    ), $config = new \Doctrine\DBAL\Configuration);
                }

                return $connection;
            }
        ];

        $builder->addDefinitions($definitions);
    }
}
